{{- $image := or .image "debian-rpi3bplus-buster-arm64-domoticz.img" -}}
architecture: arm64

actions:
  - action: debootstrap
    suite: "buster"
    components:
      - main
      - contrib
      - non-free
    mirror: https://deb.debian.org/debian

  - action: apt
    recommends: false
    packages: [ adduser,
                firmware-brcm80211,
                linux-image-arm64,
                locales,
                nano, 
                net-tools,
                openssh-server,
                raspi3-firmware,
                sudo,  
                systemd-sysv,
                x11-xkb-utils,
                wget,
                zlib1g-dev]

  - action: run
    chroot: true
    script: scripts/setup-user.sh


  - action: run
    chroot: true
    command: echo "console=ttyS0,115200 console=tty1 root=/dev/mmcblk0p2 rootfstype=ext4  fsck.repair=yes rootwait" > /boot/cmdline.txt


  # Configure interfaces --> eth0 dhcp
  - action: overlay
    source: overlays/interfaces

  # Add brcmfmac files
  - action: overlay
    source: overlays/brcm

  # Add locale files : keyboard & language --> FR
  - action: overlay
    source: overlays/locale

  # Change timeZone
  - action: run
    chroot: true
    command: ln -s /usr/share/zoneinfo/Europe/Paris /etc/localtime

  - action: run
    chroot: true
    script: scripts/setup-locale.sh

  - action: run
    chroot: true
    command: echo raspberrypi > /etc/hostname; echo "127.0.0.1  raspberrypi" > /etc/hosts

  - action: run
    chroot: true
    command: cp /usr/lib/linux-image-*/broadcom/bcm2837-*.dtb /boot/firmware/

  - action: run
    chroot: true
    command: touch /boot/ssh

  - action: run
    chroot: true
    command: echo "hdmi_force_hotplug=1" >> /boot/firmware/config.txt && echo "hdmi_drive=2" >> /boot/firmware/config.txt 

  - action: image-partition
    imagename: {{ $image }}
    imagesize: 2GB
    partitiontype: msdos
    mountpoints:
      - mountpoint: /
        partition: root
      - mountpoint: /boot/firmware
        partition: firmware
        options: [ x-systemd.automount ]
    partitions:
      - name: firmware
        fs: fat32
        start: 0%
        end: 256MB
      - name: root
        fs: ext4
        start: 256MB
        end: 100%

  - action: filesystem-deploy
    description: Deploying filesystem onto image

  - action: run
    postprocess: true
    command: gzip -f {{ $image }}
